;paint2sound v1.01

;converts any loaded bmp or jpg image or any image painted/drawn by user, to a soundscape
;Each pixel row represents a frequency band. The application synthesizes sine waves For each pixel row 
;with an instantaneous amplitude determined by the brightness of each pixel in the pixel row, and then sums together 
;all the sine waves. There is user control over various parameters like sample rate, sound duration, how frequencies are 
;distributed across the pixel rows and the overall level in the mix of each sine wave

;by DoctorNash, with small modifications by Infratec


XIncludeFile "PortAudio.pb"
XIncludeFile "CurveGadget.pbi"

Global Dim CurvePoint.POINT(1)
Global No2
Global Dim FreqBandAmplArr.f(0)
Global VolADSRClicked.i = 0

Global ptA.f = 0.5
Global ptB.f = 0.06
Global ptC.f = 0.75
Global ptD.f = 0.75

UseJPEGImageDecoder()

#PictureSize = 380

PurifierGranularity(1, 1, 1, 1)

Procedure Error(err)
  Debug Pa_GetErrorText(err)
  MessageRequester("", PeekS(Pa_GetErrorText(err)))
  End
EndProcedure


Declare CreateSoundArray()
Declare.f GetPtVal(Nee.l, kee.l, SegLen.l)
Declare.f GetPtValBak(Nee.l, kee.l, SegLen.l)
Declare.f SlidePointReturn(Noo.l, koo.l, NextSeg.l, Segln.l)
Declare.f SineVal(naa.l, kaa.l)
Declare GetThePixelVals()
Declare.i MaxOrMin(MinOpt.i, MaxOpt.i)
Declare RepeatPlay()
Declare NormalizeSound()
Declare RefreshProgressBar(TheNum.i)
Declare MoveTheMarker(ThePoint.i)
Declare.f DefaultExpFreq(StepNum.l, FromFrq.l, ToFrq.l)
Declare.f CubicBezier(xval.f, aval.f, bval.f, cval.f, dval.f, FromFrq.l, ToFrq.l)
Declare.f slopeFromT(tee.f, Ai.f, Bi.f, Ci.f)
Declare.f xFromT(tee.f, Ai.f, Bi.f, Ci.f, Di.f)
Declare.f yFromT(tee.f, Ei.f, Fi.f, Gi.f, Hi.f)
Declare DrawTheBezier()
Declare.f ADSRFreqBandAmplitude(StepNum.l)
Declare ImageRotater()
Declare ShowAboutWindow()

Global Dim PixelAmplArr.f(0,0)

Global Dim PixelValArr.i(0,0) ;this holds the raw RGB value of each pixel for image rotation purposes

Global SampleRate.i

Global Dim a.i(2) ;Array To hold RGB values. not really necessary, but hey
Global Dim FinalSoundArr.f(0)

SampleRate = 3000

Global Pt.l = 0
Global NextSegment.l
Global Garo.l
Global SoundLenSecs.f
Global PortAudioSoundLen.i
Global Totlen.l
Global DoRepeat.i = #False
Global Dim FreqArr.f(0)

Global Pi2 = #PI*2

Global NFactor.l = 0

Global Nm.l = 0
Global Im.l = 0

Global TheFromFreq.l = 70
Global TheToFreq.l = 9000

Global ExpFlag.i = #False
Global Dim BezierDrawArr.f(0)

SoundLenSecs = 5 ;determines how quickly we scan thru the image. in seconds. set To 5 sec As Default on slider
PortAudioSoundLen = SoundLenSecs*1000
Totlen = (SampleRate*SoundLenSecs)

Enumeration
  #IMAGE_Content  ;stores the previous CanvasGadget content while the mouse is down
  #IMAGE_Color
EndEnumeration

Enumeration
  #GADGET_Canvas
  #GADGET_Color
  #GADGET_BrushWidth
  #GADGET_Brush
  #GADGET_Line
  #GADGET_Box
  #GADGET_Clear
  #GADGET_Synthesize
  #Gadget_Repeat
  #GADGET_TextFrom
  #GADGET_TrackFrom
  #GADGET_TextTo
  #GADGET_TrackTo
  #GADGET_Geometric
  #GADGET_TextSamplerate
  #GADGET_TrackSamplerate
  #GADGET_TextDuration
  #GADGET_TrackDuration
  #GADGET_Save
  #GADGET_Load
  #GADGET_Canvas2
  #GADGET_TrackA
  #GADGET_TrackB
  #GADGET_TrackC
  #GADGET_TrackD
  #GADGET_TextDistribution
  #GADGET_TextVolADSR
  #GADGET_RotateImage
  #Frame3D_1
  #IMAGE_DISPLAY
  #IMAGE_MEMORY
EndEnumeration

Global CurrentColor, CurrentMode, StartX, StartY

;Draw the mouse action result depending on the currently selected mode and event type

Procedure DrawAction(x, y, EventType)
  If StartDrawing(CanvasOutput(#GADGET_Canvas))
    Select CurrentMode
   
      Case #GADGET_Brush
        If EventType = #PB_EventType_LeftButtonDown Or EventType = #PB_EventType_MouseMove
          Circle(x, y, GetGadgetState(#GADGET_BrushWidth), CurrentColor)
        EndIf
       
      Case #GADGET_Line
        DrawImage(ImageID(#IMAGE_Content), 0, 0)
        LineXY(StartX, StartY, x, y, CurrentColor)
     
      Case #GADGET_Box
        DrawImage(ImageID(#IMAGE_Content), 0, 0)
        Box(StartX, StartY, x-StartX, y-StartY, CurrentColor)
 
    EndSelect
   
    StopDrawing()
  EndIf

EndProcedure

CurrentColor = $ffffff
CurrentMode  = #GADGET_Brush
CreateImage(#IMAGE_Color, 35, 35, 24)
CreateImage(#IMAGE_Content, #PictureSize, #PictureSize, 24)

If OpenWindow(0, 0, 0, 720, 425, "Paint2Sound", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  
  If CreateMenu(0, WindowID(0))    ; menu creation starts....
    MenuTitle("File")
    MenuItem(1, "Exit")
    MenuTitle("?")
    MenuItem(3, "About")
    MenuItem(4, "Help")
  EndIf
  
  No2 = CurveGadget(#PB_Any, 530, 310, 160, 70, 8, $ffffff, $000000)
  CurveGadgetSetAttribute(No2, #CurveGadget_PointRadius, 3)
  CurveGadgetSetAttribute(No2, #CurveGadget_CatchRadius, 10)
  CurveGadgetSetAttribute(No2, #CurveGadget_X_Maximum, 380)
  CurveGadgetSetAttribute(No2, #CurveGadget_Y_Maximum, 10000)

  CanvasGadget(#GADGET_Canvas, 10, 10, #PictureSize, #PictureSize, #PB_Canvas_ClipMouse)
  CanvasGadget(#GADGET_Canvas2, 530, 115, 160, 70, #PB_Canvas_ClipMouse)
  StartDrawing(CanvasOutput(#GADGET_Canvas2))
  Box(0, 0, 160, 70, $000000)
  StopDrawing()
  
  Frame3DGadget(#Frame3D_1, 505, 2, 205, 390, "Sound")
  
  ButtonGadget(#GADGET_Brush,  400, 70, 50, 25, "Brush",  #PB_Button_Toggle)
  SpinGadget(#GADGET_BrushWidth, 460, 70, 30, 25, 1, 11, #PB_Spin_ReadOnly|#PB_Spin_Numeric)
  SetGadgetState (#GADGET_BrushWidth, 8) : SetGadgetText(#GADGET_BrushWidth, "8")
  ButtonImageGadget(#GADGET_Color, 400, 10, 50, 50, ImageID(#IMAGE_Color))
  ButtonGadget(#GADGET_Line,   400, 100, 50, 25, "Line",   #PB_Button_Toggle)
  ButtonGadget(#GADGET_Clear,  400, 130, 50, 25, "Clear")
  SetGadgetState(#GADGET_Brush, 1)
  SetGadgetAttribute(#GADGET_Canvas, #PB_Canvas_Cursor, #PB_Cursor_Cross)
 
  ButtonGadget(#GADGET_RotateImage, 400, 160, 50, 25, "Rotate")
 
  ButtonGadget(#GADGET_Synthesize, 400, 215, 70, 40, "Synthesize")
  CheckBoxGadget(#Gadget_Repeat, 410, 265, 60, 20, "Repeat")

  TextGadget(#GADGET_TextFrom, 620, 195, 50, 20, "Frq From")
  TrackBarGadget(#GADGET_TrackFrom, 640, 210, 20, 80, 70, 1500, #PB_TrackBar_Vertical)
  SetGadgetState(#GADGET_TrackFrom,90)
  levelfrom = 90
 
  TextGadget(#GADGET_TextTo, 670, 195, 50, 20, "Frq To")
  TrackBarGadget(#GADGET_TrackTo, 680, 210, 20, 80, 70, 9000, #PB_TrackBar_Vertical)
  SetGadgetState(#GADGET_TrackTo,9000)
  levelto = 9000
 
  CheckBoxGadget(#GADGET_Geometric, 530, 90, 170, 20, "Enable Frequency Distribution")
 
  TextGadget(#GADGET_TextSamplerate, 560, 55, 100, 20, "Sample Rate")
  TrackBarGadget(#GADGET_TrackSamplerate, 510, 70, 180, 20, 2000, 22050)
  SetGadgetState(#GADGET_TrackSamplerate, 3000)
 
  TextGadget(#GADGET_TextDuration, 560, 15, 100, 20, "Sound Duration")
  TrackBarGadget(#GADGET_TrackDuration, 510, 30, 180, 20, 1000, 15000)
  SetGadgetState(#GADGET_TrackDuration, 5000)
 
  ButtonGadget(#GADGET_Save, 400, 320, 50, 20, "Save")
  ButtonGadget(#GADGET_Load, 400, 350, 50, 20, "Load")
 
  TrackBarGadget(#GADGET_TrackA, 530, 210, 20, 80, 1, 99, #PB_TrackBar_Vertical)
  SetGadgetState(#GADGET_TrackA, 50)
  TrackBarGadget(#GADGET_TrackB, 550, 210, 20, 80, 1, 99, #PB_TrackBar_Vertical)
  SetGadgetState(#GADGET_TrackB, 5)
  TrackBarGadget(#GADGET_TrackC, 570, 210, 20, 80, 1, 99, #PB_TrackBar_Vertical)
  SetGadgetState(#GADGET_TrackC, 75)
  TrackBarGadget(#GADGET_TrackD, 590, 210, 20, 80, 1, 99, #PB_TrackBar_Vertical)
  SetGadgetState(#GADGET_TrackD, 75)
 
  TextGadget(#GADGET_TextDistribution, 525, 195, 90, 20, "Adjust Distribution")
  TextGadget(#GADGET_TextVolADSR, 540, 290, 150, 20, "Adjust Frequency Band Level")
 
  StartDrawing(CanvasOutput(#GADGET_Canvas))
  Box(0, 0, #PictureSize, #PictureSize, $000000)
  StopDrawing()
 
  StartDrawing(ImageOutput(#IMAGE_Color))
  Box(0, 0, 35, 35, $ffffff)
  StopDrawing()
  
  Exit = #False
  Repeat
    Event = WaitWindowEvent()
    
    Select EventWindow()
        
      Case 0  ; main window
        
        Select Event
          
          Case #PB_Event_Menu
            Select EventMenu()
              Case 1 : Exit = #True
              Case 3 : MessageRequester("About", "Paint2Sound v1.01 " + Chr(169) + " Jim Singh" + #LF$ + #LF$ + "Helping you to hear your pictures")
              Case 4 : ShowAboutWindow()
            EndSelect
          
          Case #PB_Event_Gadget
            
            Select EventGadget()
              
              Case #GADGET_Canvas
                X = GetGadgetAttribute(#GADGET_Canvas, #PB_Canvas_MouseX)
                Y = GetGadgetAttribute(#GADGET_Canvas, #PB_Canvas_MouseY)
                Type = EventType()
                
                Select EventType()
                
                  Case #PB_EventType_LeftButtonDown
                    ;SetGadgetState(10, #PB_Checkbox_Unchecked)
                    SetGadgetState(#Gadget_Repeat, #PB_Checkbox_Unchecked)
                    DoRepeat = #False
                    ; This stores the current content of the CanvasGadget in #IMAGE_Content, so it can be re-drawn While the mouse moves:
                    If StartDrawing(ImageOutput(#IMAGE_Content))
                      DrawImage(GetGadgetAttribute(#GADGET_Canvas, #PB_Canvas_Image), 0, 0)
                      StopDrawing()
                    EndIf
                    
                    StartX = X
                    StartY = Y
                    DrawAction(X, Y, EventType())
                    
                  Case #PB_EventType_LeftButtonUp
                    ;DrawAction(X, Y, EventType())
                    ;SaveLastImage()
                    
                  Case #PB_EventType_MouseMove
                    If GetGadgetAttribute(#GADGET_Canvas, #PB_Canvas_Buttons) & #PB_Canvas_LeftButton
                      DrawAction(X, Y, EventType())           
                    EndIf
                    
                EndSelect
              
              Case #GADGET_Color
                CurrentColor = ColorRequester(CurrentColor)
                If StartDrawing(ImageOutput(#IMAGE_Color))
                  Box(0, 0, 35, 35, CurrentColor)
                  StopDrawing()
                  SetGadgetAttribute(#GADGET_Color, #PB_Button_Image, ImageID(#IMAGE_Color))
                EndIf
                
              Case #GADGET_Brush, #GADGET_Line
                EventGadget = EventGadget()
                For Gadget = #GADGET_Brush To #GADGET_Line
                  If Gadget = EventGadget
                    SetGadgetState(Gadget, 1)
                  Else
                    SetGadgetState(Gadget, 0) ; unset the state of all other gadgets
                  EndIf
                Next Gadget         
                CurrentMode = EventGadget   
                
              Case #GADGET_Clear
                ;SetGadgetState(10, #PB_Checkbox_Unchecked)
                SetGadgetState(#Gadget_Repeat, #PB_Checkbox_Unchecked)
                DoRepeat = #False
                If StartDrawing(CanvasOutput(#GADGET_Canvas))
                  Box(0, 0, #PictureSize, #PictureSize, $000000)
                  StopDrawing()
                EndIf
                
              Case #GADGET_Synthesize
                CreateImage(#IMAGE_Content, #PictureSize, #PictureSize, 24)
                StartDrawing(ImageOutput(#IMAGE_Content))
                DrawImage(GetGadgetAttribute(#GADGET_Canvas, #PB_Canvas_Image), 0, 0)
                StopDrawing()
                nm = 0
                im = 0
                hom = 0
                If Not DoRepeat
                  GetThePixelVals()
                  CreateSoundArray()
                EndIf
                RepeatPlay()
                
              Case #Gadget_Repeat
                If GetGadgetState(#Gadget_Repeat)
                  DoRepeat = #True
                Else
                  DoRepeat = #False
                EndIf
                
              Case #GADGET_TrackFrom
                SetGadgetState(#Gadget_Repeat, #PB_Checkbox_Unchecked)
                DoRepeat = #False
                LevelFrom = GetGadgetState(#GADGET_TrackFrom)
                If GetGadgetState(#GADGET_TrackFrom) > levelto
                  SetGadgetState(#GADGET_TrackFrom, levelto)
                EndIf
                TheFromFreq = GetGadgetState(#GADGET_TrackFrom)
                
              Case #GADGET_TrackTo
                SetGadgetState(#Gadget_Repeat, #PB_Checkbox_Unchecked)
                DoRepeat = #False
                Levelto = GetGadgetState(#GADGET_TrackTo)
                If GetGadgetState(#GADGET_TrackTo) < levelfrom
                  SetGadgetState(#GADGET_TrackTo, levelfrom)
                EndIf
                TheToFreq = GetGadgetState(#GADGET_TrackTo)
                
              Case #GADGET_TrackSamplerate
                SetGadgetState(#Gadget_Repeat, #PB_Checkbox_Unchecked)
                DoRepeat = #False
                SampleRate = GetGadgetState(#GADGET_TrackSamplerate)
                Totlen = SampleRate * SoundLenSecs
                
              Case #GADGET_TrackDuration
                SetGadgetState(#Gadget_Repeat, #PB_Checkbox_Unchecked)
                DoRepeat = #False
                SoundLenSecs = GetGadgetState(#GADGET_TrackDuration) / 1000
                PortAudioSoundLen = GetGadgetState(#GADGET_TrackDuration)
                Totlen = SampleRate * SoundLenSecs
                
              Case #GADGET_TrackA
                SetGadgetState(#Gadget_Repeat, #PB_Checkbox_Unchecked)
                DoRepeat = #False
                ptA = GetGadgetState(#GADGET_TrackA)/100
                DrawTheBezier()
              Case #GADGET_TrackB
                SetGadgetState(#Gadget_Repeat, #PB_Checkbox_Unchecked)
                DoRepeat = #False
                ptB = GetGadgetState(#GADGET_TrackB)/100 
                DrawTheBezier()
              Case #GADGET_TrackC
                SetGadgetState(#Gadget_Repeat, #PB_Checkbox_Unchecked)
                DoRepeat = #False
                ptC = GetGadgetState(#GADGET_TrackC)/100
                DrawTheBezier()
              Case #GADGET_TrackD
                SetGadgetState(#Gadget_Repeat, #PB_Checkbox_Unchecked)
                DoRepeat = #False
                ptD = GetGadgetState(#GADGET_TrackD)/100
                DrawTheBezier()
                
              Case #GADGET_Geometric
                SetGadgetState(#Gadget_Repeat, #PB_Checkbox_Unchecked)
                DoRepeat = #False
                ExpFlag = GetGadgetState(#GADGET_Geometric)
                If ExpFlag
                  DrawTheBezier()
                Else
                  StartDrawing(CanvasOutput(#GADGET_Canvas2))
                  Box(0, 0, 160, 70, $000000)
                  StopDrawing()
                EndIf 
                
              Case #GADGET_RotateImage
                SetGadgetState(#Gadget_Repeat, #PB_Checkbox_Unchecked)
                DoRepeat = #False
                ImageRotater()
                
              Case #GADGET_Save
                Filename$ = SaveFileRequester("Save", "", "Bitmap (*.bmp)|*.bmp|JPG (*.jpg)|*.jpg", 0)
                If Filename$
                  If SelectedFilePattern() = 0
                    If Right(Filename$, 4) <> ".bmp" : Filename$ + ".bmp" : EndIf
                  Else
                    If Right(Filename$, 4) <> ".jpg" : Filename$ + ".jpg" : EndIf
                  EndIf
                  TempImg = CreateImage(#PB_Any, 380, 380)
                  StartDrawing(ImageOutput(TempImg))
                  DrawImage(GetGadgetAttribute(#GADGET_Canvas, #PB_Canvas_Image), 0, 0)
                  StopDrawing()
                  SaveImage(TempImg, Filename$)
                  FreeImage(TempImg)
                  
                  OpenPreferences(Filename$ + ".p2s")
                  WritePreferenceInteger("SoundDuration", GetGadgetState(#GADGET_TrackDuration))
                  WritePreferenceInteger("SampleRate", GetGadgetState(#GADGET_TrackSamplerate))
                  WritePreferenceInteger("FrqFrom", GetGadgetState(#GADGET_TrackFrom))
                  WritePreferenceInteger("FrqTo", GetGadgetState(#GADGET_TrackTo))
                  WritePreferenceInteger("FrqDistribution", GetGadgetState(#GADGET_Geometric))
                  WritePreferenceInteger("FrqDistA", GetGadgetState(#GADGET_TrackA))
                  WritePreferenceInteger("FrqDistB", GetGadgetState(#GADGET_TrackB))
                  WritePreferenceInteger("FrqDistC", GetGadgetState(#GADGET_TrackC))
                  WritePreferenceInteger("FrqDistD", GetGadgetState(#GADGET_TrackD))
                  Dim CurveArray.Point(1)
                  CurveGadgetGetState(No2, CurveArray(), #False)
                  For i = 1 To 8
                    WritePreferenceString("FrqBandP" + Str(i), Str(CurveArray(i - 1)\x) + "," + Str(CurveArray(i - 1)\y))
                  Next i
                  ClosePreferences()
                EndIf
                
              Case #GADGET_Load
                Pattern$ = "Bitmap (*.bmp)|*.bmp|JPG (*.jpg)|*.jpg"
                Filename$ = OpenFileRequester("Load", "", Pattern$, 0)
                If Filename$
                  SetGadgetState(#Gadget_Repeat, #PB_Checkbox_Unchecked)
                  DoRepeat = #False
                  TempImg = LoadImage(#PB_Any, Filename$)
                  ResizeImage(TempImg, 380, 380)
                  If TempImg
                    SetGadgetAttribute(#GADGET_Canvas, #PB_Canvas_Image, ImageID(TempImg))
                    FreeImage(TempImg)
                  EndIf
                  
                  If OpenPreferences(Filename$ + ".p2s")
                    SetGadgetState(#GADGET_TrackDuration, ReadPreferenceInteger("SoundDuration", 5000))
                    SetGadgetState(#GADGET_TrackSamplerate, ReadPreferenceInteger("SampleRate", 3000))
                    SetGadgetState(#GADGET_TrackFrom, ReadPreferenceInteger("FrqFrom", 90))
                    SetGadgetState(#GADGET_TrackTo, ReadPreferenceInteger("FrqTo", 9000))
                    If ReadPreferenceInteger("FrqDistribution", 0) = 1
                      SetGadgetState(#GADGET_Geometric, 1)
                      ExpFlag = #True
                    Else
                      SetGadgetState(#GADGET_Geometric, 0)
                      ExpFlag = #False
                    EndIf
                    SetGadgetState(#GADGET_TrackA, ReadPreferenceInteger("FrqDistA", 50))
                    ptA = GetGadgetState(#GADGET_TrackA)/100
                    SetGadgetState(#GADGET_TrackB, ReadPreferenceInteger("FrqDistB", 5))
                    ptB = GetGadgetState(#GADGET_TrackB)/100
                    SetGadgetState(#GADGET_TrackC, ReadPreferenceInteger("FrqDistC", 75))
                    ptC = GetGadgetState(#GADGET_TrackC)/100
                    SetGadgetState(#GADGET_TrackD, ReadPreferenceInteger("FrqDistD", 75))
                    ptD = GetGadgetState(#GADGET_TrackD)/100
                    DrawTheBezier()
                    
                    Dim CurveArray.Point(7)
                    For i = 0 To 7
                      FrqBand$ = ReadPreferenceString("FrqBandP" + Str(i + 1), "0,0")
                      CurveArray(i)\x = Val(StringField(FrqBand$, 1, ","))
                      CurveArray(i)\y = Val(StringField(FrqBand$, 2, ","))
                    Next i
                    CurveGadgetSetState(No2, CurveArray(), #False)
                    ClosePreferences()
                  EndIf
                  
                EndIf
                
              Case No2
                If CurveGadgetEvent(No2) = 1
                  If CurveGadgetGetState(No2, CurvePoint())
                    SetGadgetState(#Gadget_Repeat, #PB_Checkbox_Unchecked)
                    DoRepeat = #False
                    VolADSRClicked = 1
                  EndIf
                EndIf
                
            EndSelect   
        
          Case #PB_Event_CloseWindow : Exit = #True
        
        EndSelect
        
        
      Case 1  ; help window
        
        Select Event
         
          ;Case #PB_Event_Gadget :  If EventGadget()=CloseButton : Break : EndIf
          Case #PB_Event_CloseWindow : CloseWindow(1)
          
        EndSelect
        
    EndSelect 
  Until Exit
 
EndIf

Procedure ShowAboutWindow()
 
  Protected AboutWindow, myEditorGadget, CloseButton
  Protected Text$
  Protected Quit
  
  If OpenWindow(1, #PB_Ignore, #PB_Ignore, 638, 265, "Paint2Sound Help", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  
    If CatchImage(#IMAGE_MEMORY, ?Image)
      ImageGadget(#IMAGE_DISPLAY, 5, 280, 280, 400, ImageID(#IMAGE_MEMORY))
    Else
      CanvasGadget(#IMAGE_DISPLAY, 5, 370, 280, 400)
    EndIf
    
    myEditorGadget = EditorGadget(#PB_Any, 5, 5, 628, 250, #PB_Editor_ReadOnly)
    
    Text$ = #LF$ + "Draw in black canvas area, load an image or draw on a loaded image and press 'Synthesize' to hear image converted to sound"
    Text$ + #LF$ + "You can change various characteristics of the sound by means of the 'Sound' group of controls at the right of the application" + Chr($d)
    Text$ + #LF$ + "*Color Selector button: Square button above the Brush button launches a color selection palette for the Brush and Line tools"+ Chr($d)
    Text$ + #LF$ + "*Line button: Click to paint lines on the black canvas area" + Chr($d)
    Text$ + #LF$ + "*Clear button: Click to completely erase your drawing or loaded image" + Chr($d)
    Text$ + #LF$ + "*Rotate button: Every Click of this button rotates the drawing or loaded image clockwise by 90 degrees" + Chr($d)
    Text$ + #LF$ + "*Synthesize button: Creates a sound from the image and then plays it while scanning across the image" + Chr($d)
    Text$ + #LF$ + "*Repeat: If you tick this checkbox and press Synthesize, the application will play the last synthesized sound" + Chr($d)
    Text$ + #LF$ + "*Save button: Allows you to save your image in .BMP (uncompressed image) format"+ Chr($d)
    Text$ + #LF$ + "*Load button: Allows you to load your saved image, or any .BMP file, or any .JPG file into the application"+ Chr($d)
    Text$ + #LF$ + "*Sound Duration slider: Sets the length of the synthesized sound - from under a second to about 12 seconds" + Chr($d)
    Text$ + #LF$ + "*Sample Rate slider: Sets resolution of the synthesized sound. A higher sound fidelity (resolution) takes longer to compute" + Chr($d)
    Text$ + #LF$ + "*Enable Frequency Distribution: Enables user-modifiable frequency distribution. If unticked, default distribution applies" + Chr($d)
    Text$ + #LF$ + "*Adjust Distribution sliders: Adjust to modify the frequency distribution curve. Curve appears in the window above the sliders" + Chr($d)
    Text$ + #LF$ + "*Frq From slider: Sets the From frequency of the frequency distribution (at the lowest point, a few tens of Hz)" +Chr($d)
    Text$ + #LF$ + "*Frq To slider: Sets the To frequency of the frequency distribution (at the highest point, around 10kHz)" + Chr($d)
    Text$ + #LF$ + "*Adjust Frequency Band Level: Adjust level in the final sound of each sinewave created from each pixel row" + Chr($d)
    
    SetGadgetText(myEditorGadget, Text$)
   
  EndIf

  DataSection
    Image:
    ;IncludeBinary "paint2sound_concepta.jpg"
  EndDataSection
  
EndProcedure


Procedure ImageRotater()
   
Protected ImageWidth.i, ImageHeight.i
Protected x.i
Protected y.i

ImageWidth = GadgetWidth(#GADGET_Canvas)
ImageHeight = GadgetHeight(#GADGET_Canvas)
ImageWidth - 1
ImageHeight - 1
 
Dim PixelValArr(ImageHeight, ImageWidth)

If StartDrawing(CanvasOutput(#GADGET_Canvas))

For x = 0 To ImageWidth
    For y = 0 To ImageHeight
      PixelValArr(x,y) = Point(x,y)
    Next y
Next x
 
Box(0, 0, #PictureSize, #PictureSize, $000000) 

For x = 0 To ImageWidth
    For y = 0 To ImageHeight
    Plot(ImageWidth-y, x, PixelValArr(x,y)) 
    Next y
Next x
StopDrawing()
EndIf   
 
EndProcedure 

Procedure GetThePixelVals()
 
  Protected Min.l, Max.l
  Protected Minf.f, Maxf.f
  Protected Hue.f
  Protected S.f, V.f
  Protected T.l, N.l
  Protected FreqSteps.f
  Protected ImageWidth.i, ImageHeight.i
  Protected Pixel.i, Gray.i
 
  ImageWidth = GadgetWidth(#GADGET_Canvas)
  ImageHeight = GadgetHeight(#GADGET_Canvas)
 
  Dim image_pixel_data.b( ImageWidth, ImageHeight )
  ImageWidth - 1
  ImageHeight - 1
 
  Dim PixelAmplArr(ImageHeight, ImageWidth)
  Dim FreqArr(ImageHeight)
  Dim FreqBandAmplArr(ImageHeight)

  StartDrawing( CanvasOutput( #GADGET_Canvas ) )
 
  For N = 0 To ImageHeight
    If Not ExpFlag
      FreqArr(N) = DefaultExpFreq(N, TheFromFreq, TheToFreq)
     Else
       FreqArr(N) = CubicBezier(N/380, ptA, ptB, ptC, ptD, TheFromFreq, TheToFreq)
    EndIf   
    FreqBandAmplArr(N) = ADSRFreqBandAmplitude(N)
  Next N

  For y = 0 To ImageHeight
    For x = 0 To ImageWidth
      Pixel = Point(x,y)
      Gray = Red(Pixel) * 77    ; 0.2989 * 256 = 76.5184
      Gray + Green(Pixel) * 150 ; 0.5870 * 256 = 150.2720
      Gray + Blue(Pixel) * 29   ; 0.1140 * 256 = 29.1840
      PixelAmplArr(y,x) = Gray / 256.0
     
    Next x
  Next y
  StopDrawing()

EndProcedure

Procedure.f DefaultExpFreq(StepNum.l, FromFrq.l, ToFrq.l)
  Protected TheVal.f
  Protected Gooda.f
    ;we have two points: the value at 50 And the End point ie the value at 380
    ;fromfreq is the value at 50 and tofreq is the value at 380
    ;a curve fitting both points is given by: y = (fromfrq/((tofrq/fromfrq)^(1/330))^50) * ((tofrq/fromfrq)^(1/330))^t
    ;so:
    Gooda = Pow((ToFrq/FromFrq),(1/330))
    TheVal = (FromFrq/(Pow(Gooda,50))) * Pow((Gooda),StepNum)
 
  ProcedureReturn TheVal
 
EndProcedure

Procedure.f ADSRFreqBandAmplitude(StepNum.l)
 
  Protected i.l
  Protected T.l
  Protected U.f
  Protected TheYPoint.f
 
  ;now each segment of the curvegadget: let us say we have a line joining (x1,y1) to (x2, y2). we want to find the value of y at
  ;an xval where x1<=xval<=x2. let us call that y value u. now whether the line is sloping up or down, the equation for u is:
  ;u = y1 + ((y2-y1)*(xval-x1)/(x2-x1)). The algorithm below works out the slope at every xval of the curvegadget, then works out
  ;the value of u according to the preceding equation. i have constrained y to 0<y<10000, so u will be in this range. so, divide the
  ;value of u by 10000 to get u in the range 0<u<1
 
  If VolADSRClicked = 1
    TheYPoint = CurveGadgetGetAttribute(No2, #CurveGadget_Y_Value_Scaled, StepNum) / 10000.0
    Debug theypoint
  Else
    TheYPoint = 0.5
  EndIf
  
  ProcedureReturn TheYPoint
 
EndProcedure 

Procedure DrawTheBezier()
 
If ExpFlag 
  Protected ImageHeight.i
  Protected N.i
  ImageHeight = GadgetHeight(#GADGET_Canvas)
  ImageHeight - 1
  Dim BezierDrawArr(159)
  For N = 0 To 159
       BezierDrawArr(N) = CubicBezier(N/160, ptA, ptB, ptC, ptD, 0, 0)
  Next N
     
  StartDrawing(CanvasOutput(#GADGET_Canvas2))
  Box(0, 0, 160, 70, $000000)
  For N = 0 To 158
    LineXY(N, BezierDrawArr(N), N+1, BezierDrawArr(N+1), $FFFFFF)
  Next N 
  StopDrawing()
EndIf     

EndProcedure 

Procedure.f CubicBezier(xval.f, aval.f, bval.f, cval.f, dval.f, FromFrq.l, ToFrq.l)
 
Protected A.f = 0
Protected B.f = 0
Protected C.f = 0
Protected D.f = 0
Protected E.f = 0
Protected F.f = 0
Protected G.f = 0
Protected H.f = 0
 
Protected y0a.f
Protected x0a.f
Protected y1a.f
Protected x1a.f
Protected y2a.f
Protected x2a.f
Protected y3a.f
Protected x3a.f
Protected currentt.f
Protected nRefinementIterations.l
Protected i.l = 0
Protected currentx.f
Protected currentslope.f
Protected CB.f

y0a = 0
x0a = 0
y1a = bval
x1a = aval
y2a = dval
x2a = cval
y3a = 1
x3a = 1

A = x3a - 3*x2a + 3*x1a - x0a
B = 3*x2a - 6*x1a + 3*x0a
C = 3*x1a - 3*x0a
D = x0a
E = y3a - 3*y2a + 3*y1a - y0a
F = 3*y2a - 6*y1a + 3*y0a       
G = 3*y1a - 3*y0a         
H = y0a

currentt = xval
nRefinementIterations = 5

For i = 0 To nRefinementIterations-1
currentx = xFromT (currentt, A,B,C,D)
currentslope = slopeFromT (currentt, A,B,C)
currentt = currentt - ((currentx - xval)*(currentslope))
Next i

If currentt>1
currentt = 1
ElseIf currentt<0
currentt=0
EndIf

CB = yFromT(currentt, E,F,G,H)
;now apply this fraction To the Frq range, and Return the Frq value
If FromFrq<>0 And ToFrq<>0
ToFrq = ToFrq-50
FromFrq = FromFrq-50
CB = ((ToFrq - FromFrq)*CB)+FromFrq
Else
  cb = cb*70
  If cb>70
    cb = 70
  EndIf
  cb = 70-cb
EndIf 
ProcedureReturn CB

EndProcedure

Procedure.f slopeFromT(tee.f, Ai.f, Bi.f, Ci.f)
Protected dtdx.f
dtdx = 1/(3*Ai*tee*tee + 2*Bi*tee + Ci)
ProcedureReturn dtdx
EndProcedure


Procedure.f xFromT(tee.f, Ai.f, Bi.f, Ci.f, Di.f)
Protected ex.f 
ex = Ai*(tee*tee*tee) + Bi*(tee*tee) + Ci*tee + Di
ProcedureReturn ex
EndProcedure

Procedure.f yFromT(tee.f, Ei.f, Fi.f, Gi.f, Hi.f)
Protected yi.f
yi = Ei*(tee*tee*tee) + Fi*(tee*tee) + Gi*tee + Hi
ProcedureReturn yi
EndProcedure

Procedure CreateSoundArray()
 
  Pt = 1
  Garo = 0
 
  Protected SegmentLen.l
  ;length of each slice in sound length in samples
  Protected N.l
  Protected k.l
  Protected SineSum.f
   
SegmentLen = (SampleRate*SoundLenSecs)/(ArraySize(PixelAmplArr(), 2))
;Say Number of rows of PixelAmplAr = T
T = ArraySize(PixelAmplArr(), 1)
;Max no. of sample points = Totlen
;Say N = sample point
;Each column is a timesliced Slot each consisting of segmentlen number of sample

ReDim FinalSoundArr(Totlen)
 
For N = 0 To Totlen
SineSum = 0
For k = 0 To T
   SineSum = SineSum + GetPtVal(N, k, SegmentLen)
Next k
FinalSoundArr(N) = SineSum
Next N

NormalizeSound()

EndProcedure

Procedure NormalizeSound()

  Protected MaxVal.d
  Protected K.l
  Protected Help.d
 
  MaxVal = 0
 
  For K = 0 To ArraySize(FinalSoundArr())
    Help = Abs(FinalSoundArr(K))
    If Help > MaxVal : MaxVal = Help : EndIf
  Next K
 
  If MaxVal > 0
    For K = 0 To ArraySize(FinalSoundArr())
      FinalSoundArr(K) = FinalSoundArr(K) / MaxVal
    Next K
  EndIf
 
EndProcedure


Procedure.f GetPtVal(Nee.l, kee.l, SegLen.l)
 
  Protected S.l
 
  ;First determine current amplitude:
  ;S = Integer value of (Nee/SegLen)
  ;So, current Amplitude = AmplVals(kee,S)
  S = Nee/SegLen
  If S > ArraySize(PixelAmplArr(), 2)
    S = ArraySize(PixelAmplArr(), 2)
  EndIf
 
  ProcedureReturn FreqBandAmplArr(kee) * PixelAmplArr(kee, S) * SineVal(nee, kee)
 
EndProcedure


Procedure.f SineVal(naa.l, kaa.l)
 
  ProcedureReturn Sin((Pi2 * FreqArr(kaa) / SampleRate) * naa)
 
EndProcedure


ProcedureC.i PaStreamCallback(*in, *output.Float, frameCount, *timeInfo.PaStreamCallbackTimeInfo, statusFlags, *userData)
 
  Static P.i
  Static Ptr.i
  Protected Im.i
  Protected Flag.i
  Protected Result = #paComplete
 
  Flag = PeekI(*userData)
 
  If Flag <> 0
    If Flag = 1
      P = 0
      Ptr = 0
      PokeI(*userData, 2)
    EndIf
   
    For Im = 1 To frameCount
      *output\f = FinalSoundArr(Ptr)
      *output + 4
      Ptr + 1
    Next Im
     
    If Ptr < ArraySize(FinalSoundArr()) - frameCount
      Result = #paContinue
    EndIf
   
    MoveTheMarker(P)
    P + 1
  EndIf
 
  ProcedureReturn Result
 
EndProcedure


ProcedureC PaStreamFinishedCallback(*userData)
  PokeI(*userData, 0)
EndProcedure


Procedure MoveTheMarker(ThePoint.i)
 
  StartDrawing(CanvasOutput(#GADGET_Canvas))
  DrawImage(ImageID(#IMAGE_Content), 0, 0)
  If ThePoint < #PictureSize : LineXY(ThePoint, 0, ThePoint, #PictureSize, $FFFFFF) : EndIf
  StopDrawing()
 
EndProcedure


Procedure RepeatPlay()
 
  Protected err.i
  Protected op.PaStreamParameters
  Protected stream.l
  Protected framesPerBuffer.l
  Protected userData.i
 
 
  err = Pa_Initialize()
  If err <> #paNoError : Error(err) : EndIf
 
  op\channelCount = 1
  op\device = Pa_GetDefaultOutputDevice()
  op\sampleFormat = #paFloat32
  op\suggestedLatency = 150/1000
 
  framesPerBuffer =  ArraySize(FinalSoundArr()) / #PictureSize
 
  userData = 1
 
  err = Pa_OpenStream(@stream, 0, @op, SampleRate, framesPerBuffer, #paNoFlag, @PaStreamCallback(), @userData)
  If err <> #paNoError : Error(err) : EndIf
 
  Pa_SetStreamFinishedCallback(stream, @PaStreamFinishedCallback())
 
  Pa_StartStream(stream)
 
  While(userData) : Delay(1) : Wend
 
  Pa_StopStream(stream)
 
  Pa_Terminate()
 
EndProcedure

ErrorHandler:
  ;Debug nm

End
; IDE Options = PureBasic 4.60 (Windows - x86)
; CursorPosition = 8
; Folding = ----
; EnableXP
; Executable = ..\Paint2SoundPrereqFiles\hooda.exe
; DisableDebugger